%global owner ckolivas
%global commit cc3e6214d415

Name:           ckpool
Version:        0.9.4
Release:        7.%{commit}%{?dist}
Summary:        Ultra low overhead massively scalable multi-process, multi-threaded modular bitcoin mining pool, proxy, passthrough, library and database interface in c for Linux.


License:        GPLv3
URL:            https://bitbucket.org/ckolivas/ckpool
Source0:        https://bitbucket.org/%{owner}/%{name}/get/%{commit}.tar.bz2 
Source1:        ckpool@.service
Source2:        ckproxy@.service
#Patch0:         %{name}_unbundle_jansson.patch

BuildRequires:  autoconf automake libtool
## Bundled jansson differs from the stock one of the same version (ck, wtf?)
##BuildRequires:  jansson-devel
#BuildRequires:  gsl-devel
#BuildRequires:  openssl-devel
#BuildRequires:  postgresql-devel
%{?systemd_requires}
BuildRequires:  systemd
BuildRequires:  yasm

%description
CKPOOL + CKDB + libckpool by Con Kolivas and Andrew Smith.

Ultra low overhead massively scalable multi-process, multi-threaded modular
bitcoin mining pool, proxy, passthrough, library and database interface in c
for Linux.

CKPOOL is code provided free of charge under the GPLv3 license but its development
is mostly paid for by commissioned funding, and the pool by default contributes
0.5% of solved blocks in pool mode to the development team. Please consider leaving
this contribution in the code if you are running it on a pool or contributing to the
authors listed in AUTHORS if you use this code to aid funding further development.

%prep
%autosetup -n %{owner}-%{name}-%{commit} -p0

%build
./autogen.sh
%configure --without-ckdb
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
%make_install
# Unbundle the bundled
find %{buildroot}/%{_prefix} -depth '(' -name '*jansson*' -o -empty ')' -delete
find . -name '*.conf' -type f -exec install -Dp -m 644 '{}' %{buildroot}/%{_sysconfdir}/'{}' ';'
mkdir -p %{buildroot}/%{_unitdir}
cp %{SOURCE1} %{SOURCE2} %{buildroot}/%{_unitdir}
mkdir -p %{buildroot}/%{_sysconfdir}/ckpool
mkdir -p %{buildroot}/%{_sysconfdir}/ckproxy

%post
%systemd_post ckpool@\*.service
%systemd_post ckproxy@\*.service

%preun
%systemd_preun ckpool@\*.service
%systemd_preun ckproxy@\*.service

%postun
%systemd_postun_with_restart ckpool@\*.service
%systemd_postun_with_restart ckproxy@\*.service

%files
%doc AUTHORS ChangeLog COPYING NEWS README
%{_bindir}/ck*
%{_bindir}/notifier
%config %{_sysconfdir}/ck*.conf
%config %{_sysconfdir}/ckpool
%config %{_sysconfdir}/ckproxy
%config %ghost %{_sysconfdir}/sysconfig/ckpool
%config %ghost %{_sysconfdir}/sysconfig/ckproxy
%{_unitdir}/*.service
#{_unitdir}/ckpool@.service
#{_unitdir}/ckproxy@.service

%changelog
* Wed May 23 2018 Vadim Raskhozhev <iamdexpl@gmail.com> - 0.9.4-7.cc3e6214d415
- Version bump

* Thu Dec 28 2017 Vadim Raskhozhev <iamdexpl@gmail.com> - 0.9.4-5.0ab1e33e8193
- Disabled ckdb support due to it seems causing crashes

* Wed Dec 27 2017 Vadim Raskhozhev <iamdexpl@gmail.com> - 0.9.4-4.0ab1e33e8193
- Added systemd units for ckpool and ckproxy

* Wed Dec 27 2017 Vadim Raskhozhev <iamdexpl@gmail.com> - 0.9.4-3.0ab1e33e8193
- Added --with-ckdb

* Tue Dec 26 2017 Vadim Raskhozhev <iamdexpl@gmail.com> - 0.9.4-2.0ab1e33e8193
- Added configs and docs

* Tue Dec 26 2017 Vadim Raskhozhev <iamdexpl@gmail.com> - 0.9.4-1.0ab1e33e8193
- Initial RPM
